$TITLE	Dynamic CGE Version of EMPAX

$if not setglobal scenario	$setglobal scenario	812_costs


*$offlisting

$if not setglobal states	$setglobal states	USA

*$setglobal size small
$if not setglobal size		$setglobal size large

*$setglobal readBAU no
$if not setglobal readBAU	$setglobal readBAU	yes


parameter
	statemod;

statemod = no;

$if not %states%==USA	statemod=yes;
display statemod;

set states /
ak,al,ar,az,ca
co,ct,dc,de,fl
ga,hi,ia,id,il
in,ks,ky,la,ma
md,me,mi,mn,mo
ms,mt,nc,nd,ne
nh,nj,nm,nv,ny
oh,ok,or,pa,ri
sc,sd,tn,tx,ut
va,vt,wa,wi,wv,wy /;

$if not %states%==USA  $goto statesolve
set r regions /
	NRTH
	SOTH
	MIDW
	PLNS
	WEST /;
$goto nextglobal

$label statesolve
set r /%states%/;
$label nextglobal

$setglobal ypp 5

$if not setglobal saveCAIR	$setglobal saveCAIR	no

$if not setglobal IPM		$setglobal IPM		no

$if not setglobal batchmode	$setglobal batchmode	yes

$if not setglobal rho		$setglobal rho		5
$if not setglobal delta		$setglobal delta	7
$if not setglobal gamma		$setglobal gamma	2.75
$if not setglobal phi		$setglobal phi		0.2
$if not setglobal w		$setglobal w		0.5
$if not setglobal c		$setglobal c		1
$if not setglobal lse_uncomp	$setglobal lse_uncomp	0.15
$if not setglobal lse_comp	$setglobal lse_comp	0.4
$if not setglobal va		$setglobal va		1.0
$if not setglobal enoe		$setglobal enoe		0.5
$if not setglobal en		$setglobal en		1.0
$if not setglobal co		$setglobal co		0.3
$if not setglobal cog		$setglobal cog		1.0
$if not setglobal gr		$setglobal gr		0.9
$if not setglobal er		$setglobal er		0.6
$if not setglobal erva		$setglobal erva		0.6
$if not setglobal ae		$setglobal ae		0.3
$if not setglobal eva		$setglobal eva		0.5
$if not setglobal eva_ele	$setglobal eva_ele	0.4
$if not setglobal dm		$setglobal dm		3
$if not setglobal mm		$setglobal mm		5
$if not setglobal dm_ele	$setglobal dm_ele	0.3
$if not setglobal mm_ele	$setglobal mm_ele	0.5
$if not setglobal t		$setglobal t		2

$include ..\mappings\EMPAX_sets_%size%.gms

alias (s,g),(g,gg),(hh,hhh),(r,rr), (r,reg);



$if %size%==large set localg(g) /CEM,cns,edu,hlt/;
$if %size%==small set localg(g) /EIS/;

set nrg(s)	/COL,CRU,ELE,GAS,OIL/;
set eles(s)	/ELE/;
set cog(s)	/COL,OIL,GAS/;
set ffe(s)	/COL,ELE,OIL,GAS/;
set ff(s)	/col,gas,oil/;
set cg(nrg)	/col,gas,oil/;
set natres(s)	/COL,CRU,GAS/;
set colgas(s)	/COL,GAS/;
set eleoil(s)	/ELE,OIL/;
set colelegas(s) /COL,ELE,GAS/;
set othnrg(s)	/COL,CRU,GAS,OIL/;
set col(s)	/COL/;
set cru(s)	/CRU/;
set ele(s)	/ELE/;
set gas(s)	/GAS/;
set oil(s)	/OIL/;
set hlt(s)	/HLT/;
set oiltrn(g)	/oil,trn/;
set indus(s);	indus(s) = g(s) - eles(s) - agr(s) - natres(s) - oil(s);
set srv(s);	srv(s) = g(s) - eles(s) - agr(s) - natres(s) - oil(s) - man(s) - eis(s) - trn(s); alias (srv,srvs), (srv,srvg);
set cong(s);	cong(s) = g(s) - col(s) - cru(s);
set srvman(g);	srvman(g) = man(g) + srv(g); alias (srvman, srvmang);
set USreg /
NRTH		North East
SOTH		South
MIDW		Mid-West
PLNS		Plains
WEST		West
/;
set mapUSreg /
NRTH.NRTH
SOTH.SOTH
MIDW.MIDW
PLNS.PLNS
WEST.WEST
(pe,nj,md,de,dc,ny,me,ct,ma,nh,ri,vt).NRTH
(fl,nc,sc,va,al,ga,la,ms,ar,tn).SOTH
(in,mi,oh,ky,wv,ia,il,mo,wi).MIDW
(tx,mn,ne,nd,sd,ks,ok).PLNS
(or,wa,id,mt,ut,nv,wy,az,co,nm,ca,ak,hi).WEST
/;

set	yr		years				/2005*2050/
	t(yr)		time periods in model 
	t0(yr)		first time period
	tt(yr)		terminal time period
	t_AEO(yr)	years in AEO forecasts		/2005*2030/
	t_IPM(yr)	years in IPM forecasts		/2010*2025/
	postAEO(yr)	years after AEO forecasts	/2031*2050/
	postIPM(yr)	years after AEO forecasts	/2026*2050/
	post2020(yr)	years after 2020		/2021*2050/;

t0(yr)$(ord(yr) eq 1) = yes;
t(yr)$(ord(yr) eq 1) = yes;
loop(yr$t(yr),
t(yr+%ypp%) = yes;
if (ord(yr)+%ypp% gt card(yr), tt(yr) = yes;);  
);

tt(yr) = yes$(ord(yr) eq card(yr));

t_AEO(yr)$(ord(yr) eq 1) = yes;
loop(yr$(t_AEO(yr) and ord(yr) lt 21),
t_AEO(yr+%ypp%) = yes;
);

display agr, man, eis, srv, trn;

parameter
	pref(yr)	Reference price path
	qref(yr)	Reference growth path
	GDPgrowth
	termgrowth	growth in last time period
	rho0		real interest rate (per year)
	rho		real interest rate (per period)
	delta0		capital depreciation rate (per year)
	delta		capital depreciation rate (per period) 
	gamma0		real growth rate (per year)
	gamma		real growth rate (per period);

rho0	= %rho%/100;
rho	= (1+rho0)**%ypp% - 1;

delta0	= %delta%/100;
delta	= 1 - (1-delta0)**%ypp%;

gamma0	= %gamma%/100;
gamma	= (1+gamma0)**%ypp% - 1;

pref(yr)	= 1 / (1+rho0)**(ord(yr)-1);
qref(yr)	= (1+gamma0)**(ord(yr)-1);

GDPgrowth(r,t) = qref(t);

display rho,gamma,delta;

parameter
inv0,gov0,c0,a0,d0,incadj,lstax
lab_endow,kendow0,BTU,ke0_shr
le0_shr,inc_shr,cd0_shr,c0_shr,tinc
tcorp,tk,tl,pld0,pkd0
deflator,dm,mm,scn,nr0
nr_endow,capshr,nr0shr,rnwshr,y0_rnw
ld0_rnw,kd0_rnw,id0_rnw,rnw_grow,RNW_endow
pxcru,pmcru,netexp,netimp,cl0
pg_bau,gov_bau,phi_cost(r,*,*,*),phi_cons,capcost
labcost,matcost,costshift,prodshift,IPM_ELEprc
IPM_GASprc,IPM_COLprc,IPM_FuelUse,IPM_Costs,IPM_FuelExp
IPM_Output,comp_match,pyelebar,pygasbar,pycolbar
ybar,inputsbar,pk0
rnw_endow,rnw_depr,adj_rnw,natres_endow
pka0,rk0,jinv0
leis0,theta_l,sigma_cl,leis_shr,tax0
ballard,chk_lambda,chk_leis,theta_w,cl_bau
FUELconv,ELECconv,RNWconv,AEEI,fuelpct
BTUs,Target,chk_USfuel,fuelprices,prc_trgt
nr_grow,eta_nr,pref_nr,esub_nr,share_nr
elecconv1,rnwconv1,eleBkWh,scaleBkWh,Settings
GDPsmooth1,GDPsmooth2,GDPdiff,GDP2020,pricepct,quantpct
RegRslt,Region_1,Region_2,Region_3,Region_4,Region_5,Region_All,Region_%states%
lse_comp	/%lse_comp%/
lse_uncomp	/%lse_uncomp%/;

$include ..\data\EMPAX_model_data_%size%.gms

display n0;


cd0_shr(r,hh,g)$sum(hhh, cd0(r,hhh,g)) = cd0(r,hh,g) / sum(hhh, cd0(r,hhh,g));
c0_shr(r,hh)$sum((hhh,g), cd0(r,hhh,g)) = sum(g, cd0(r,hh,g)) / sum((hhh,g), cd0(r,hhh,g));
ke0_shr(r,hh) = ke0(r,hh) / sum(hhh, ke0(r,hhh));
le0_shr(r,hh) = le0(r,hh) / sum(hhh, le0(r,hhh));
inc_shr(r,hh) = (ke0(r,hh) + le0(r,hh)) / (sum(hhh, ke0(r,hhh)+le0(r,hhh)));

display inc_shr;

$include ..\data\tax_rates_5_reg_%size%.dat

set	asset		type of capital asset/
	equip		Equipment
	struc		Structures
	invent		Inventories
	land		Land
	intang		Intangibles /;

tk(r,s) = sum(USreg$mapUSreg(r,USreg), tk(USreg,s));
t_corp(r) = sum(USreg$mapUSreg(r,USreg), t_corp(USreg));
t_PIT(r) = sum(USreg$mapUSreg(r,USreg), t_PIT(USreg));
alpha_K(r,s) = sum(USreg$mapUSreg(r,USreg), alpha_K(USreg,s));
beta_K(r,s) = sum(USreg$mapUSreg(r,USreg), beta_K(USreg,s));
gamma_K(r,s) = sum(USreg$mapUSreg(r,USreg), gamma_K(USreg,s));

tinc(r,s)	= t_PIT(r);
tcorp(r,s)	= t_corp(r);
tk(r,s)		= tk(r,s);
tl(r,s)		= tlfica(r) + tinc(r,s);

parameter pid0, pcd0;
pld0(r,s)	= 1 + tl(r,s);
pkd0(r,s)	= 1 + tk(r,s);
pid0(r,g,s)	= 1 + ti(r,g,s);
pcd0(r,s)	= 1 + tc(r,s);

kd0(r,s)	= kd0(r,s) / pkd0(r,s);
ld0(r,s)	= ld0(r,s) / pld0(r,s);
c0(r,hh)	= sum(g, cd0(r,hh,g)*pcd0(r,g));

* deflator converts from 2005$ to 2006$ (based on AEO GDP deflator)
deflator	= 1.0306;

nr_endow(r,hh,g) = nd0(r,g) * inc_shr(r,hh);

nr_endow(r,hh,g) = nd0(r,g) * inc_shr(r,hh);

natres_endow(r,reg,hh,g,t) = qref(t) * nr_endow(reg,hh,g) * (nr_endow(r,hh,g)/sum(rr,nr_endow(rr,hh,g)));

kd0(r,"ele")	= kd0(r,"ele") * pkd0(r,"ele") + ty(r,"ele")*y0(r,"ele");
ld0(r,"ele")	= ld0(r,"ele") * pld0(r,"ele");


rnwshr(r)	= y0_EIA("billKWh",r,"Renew","2005") / y0_EIA("billKWh",r,"ELE","2005");
y0_rnw(r)	= y0(r,"ELE")*rnwshr(r);
y0(r,"ELE")	= y0(r,"ELE")*(1-rnwshr(r));

ld0_rnw(r)	= ( y0_rnw(r) * (ld0(r,"ELE")/(y0(r,"ELE")+y0_rnw(r))) * ( (8.9/33.3) / (5.1/24.9)) );
kd0_rnw(r)	= ( y0_rnw(r) * (kd0(r,"ELE")/(y0(r,"ELE")+y0_rnw(r))) * ( (18.2/33.3) / (11.9/24.9)) );
id0_rnw(r,g)$(not nrg(g)) = (y0_rnw(r) - ld0_rnw(r) - kd0_rnw(r)) * id0(r,g,"ELE") / sum(gg$(not nrg(gg)), id0(r,gg,"ELE"));

ld0(r,"ELE")	= ld0(r,"ELE") - ld0_rnw(r);
kd0(r,"ELE")	= kd0(r,"ELE") - kd0_rnw(r);
id0(r,g,"ELE")	= id0(r,g,"ELE") - id0_rnw(r,g);
ld0(r,"ele")	= ld0(r,"ele") / pld0(r,"ele");

ld0_rnw(r)	= ld0_rnw(r) / pld0(r,"ele");
kd0(r,"ele")	= kd0(r,"ele") - ty(r,"ele")*y0(r,"ele");
kd0_rnw(r)	= kd0_rnw(r) - ty(r,"ele")*y0_rnw(r);
kd0(r,"ele")	= kd0(r,"ele") / pkd0(r,"ele");
kd0_rnw(r)	= kd0_rnw(r) / pkd0(r,"ele");

ke0(r,hh)	= sum(s, kd0(r,s)) * ke0_shr(r,hh);
le0(r,hh)	= (sum(s, ld0(r,s)) + ld0_rnw(r)) * le0_shr(r,hh);

rnw_endow(r,reg,hh) = inc_shr(r,hh) * kd0_rnw(reg) * (kd0_rnw(r)/sum(rr,kd0_rnw(rr))); 
rnw_grow(r,yr)	= qref(yr);
rnw_depr(yr) = 1 - ((1-delta0)**ord(yr)) / qref(yr);
adj_rnw(yr) = 1;

pk0		= (1+rho) * (1+%phi%*(delta+gamma));
pka0		= %phi% * (delta+gamma)**2/2;
rk0		= pk0*(rho+delta)/(1+rho)-pka0;
ke0(r,hh)	= (sum(s, kd0(r,s)) * ke0_shr(r,hh)) / rk0;
jinv0(r)	= sum(hh, ke0(r,hh)) * (delta+gamma);
inv0(r)		= jinv0(r) * (1 + %phi% * jinv0(r) / (2*sum(hh,ke0(r,hh))));
kendow0(r)	= sum(hh, ke0(r,hh));

variable		obj;

positive variables	x0_, m0_, i0_;

equations		objdef, invtrgt, bal_trade;

objdef..		obj =e=		sum((r,g)$x0(r,g,"ftrd"), sqr(x0_(r,g)/x0(r,g,"ftrd")-1)) + sum((r,g)$m0(r,g,"ftrd"), sqr(m0_(r,g)/m0(r,g,"ftrd")-1)) ;
bal_trade(r,g)..	i0_(r,g) + x0_(r,g) - m0_(r,g) =e= i0(r,g) + x0(r,g,"ftrd") - m0(r,g,"ftrd");
invtrgt(r)..		sum(g,i0_(r,g)) =e= inv0(r);
model investing /objdef, bal_trade, invtrgt/;

i0_.l(r,g)				= i0(r,g);
x0_.lo(r,g)				= 0.05 * x0(r,g,"ftrd");
x0_.l(r,g)				= x0(r,g,"ftrd");
x0_.up(r,g)				= 10 * x0(r,g,"ftrd");
x0_.fx(r,g)$(x0(r,g,"ftrd") eq 0)	= 0;
m0_.lo(r,g)				= 0.05 * m0(r,g,"ftrd");
m0_.l(r,g)				= m0(r,g,"ftrd");
m0_.up(r,g)				= 10 * m0(r,g,"ftrd");
m0_.fx(r,g)$(m0(r,g,"ftrd") eq 0)	= 0;
x0_.fx(r,nrg)				= x0(r,nrg,"ftrd");
m0_.fx(r,nrg)				= m0(r,nrg,"ftrd");
i0_.fx(r,nrg)				= 0;
solve investing using nlp minimizing obj;




i0(r,g)		= i0_.l(r,g);
x0(r,g,"ftrd")	= x0_.l(r,g);
m0(r,g,"ftrd")	= m0_.l(r,g);

* reclassify intraregional trade (n0) as domestic goods (d0)
display x0,n0;

x0(r,g,"dtrd")$(not nrg(g))	= x0(r,g,"dtrd") - sum(reg$(ord(r) eq ord(reg)), n0(r,reg,g));
n0(r,r,g)$(not nrg(g))		= 0;

display x0,n0;

d0(r,g)				= y0(r,g) + y0_rnw(r)$eles(g) - x0(r,g,"ftrd") - x0(r,g,"dtrd");
$if %states%==USA	a0(r,g) = d0(r,g) + m0(r,g,"ftrd") + sum(reg,n0(r,reg,g));
$if not %states%==USA	a0(r,g) = d0(r,g) + m0(r,g,"ftrd") + sum(states, n0(r,states,g));

display d0,a0,m0;

parameter
	chk_n0;

chk_n0("n0",r,g) = sum(states, n0(r,states,g));
chk_n0("m0",r,g) = m0(r,g,"dtrd");
display chk_n0;

theta_l(r,hh) = lse_comp - lse_uncomp;
leis0(r,hh) = sum(g,cd0(r,hh,g)) * (theta_l(r,hh)/(1-theta_l(r,hh)));
le0(r,hh) = le0(r,hh) + leis0(r,hh);
sigma_cl(r,hh) = ( lse_comp/(1-theta_l(r,hh)) ) * ( (le0(r,hh) - leis0(r,hh)) / leis0(r,hh));
ballard(r,hh) = le0(r,hh) / ( le0(r,hh) - leis0(r,hh));
leis_shr(r,hh) = leis0(r,hh) / (leis0(r,hh) + sum(g, cd0(r,hh,g)));
chk_lambda(r,hh) = (le0(r,hh)-leis0(r,hh)) / le0(r,hh);
chk_leis(r,hh) = leis0(r,hh) / (le0(r,hh) - leis0(r,hh));
lab_endow(r,hh,t) = le0(r,hh) * qref(t);
cl0(r,hh) = c0(r,hh) + leis0(r,hh);
tax0(r) 
	=  sum(s, (pld0(r,s)-1)*ld0(r,s) + (pkd0(r,s)-1)*kd0(r,s) + ty(r,s)*y0(r,s) ) 
	+ ty(r,"ele")*y0_rnw(r) 
	+ (pkd0(r,"ele")-1)*kd0_rnw(r) 
	+ (pld0(r,"ele")-1)*ld0_rnw(r)
	+ sum((g,s), (pid0(r,g,s)-1)*id0(r,g,s))
	+ sum((hh,g), (pcd0(r,g)-1)*cd0(r,hh,g));

gov0(r) = sum(g, g0(r,g));
lstax(r,hh) = (gov0(r) - tax0(r)) * c0_shr(r,hh);

loop((t0,tt), theta_w = ((1-rho0)*(1+gamma0))**(5+2050-2005););
cl_bau(r,hh) = qref("2050");

pxcru(t)		= pref(t);
pmcru(t)		= pref(t);
netexp(r)		= max( (y0(r,"cru")-sum(s,id0(r,"cru",s))-g0(r,"cru")), 0);
netimp(r)		=-min( (y0(r,"cru")-sum(s,id0(r,"cru",s))-g0(r,"cru")), 0);
pyelebar(r,t)		= 1;
ybar(r,s,t)		= qref(t);
inputsbar(r,cog,t)	= qref(t);
pygasbar(r,t)		= 1;
pycolbar(r,t)		= 1;
pg_bau(r,t)		= pref(t);
gov_bau(r,t)		= qref(t);
costshift(r,s,t)	= 0;
prodshift(r,s,t)	= 1;
phi_cost(r,g,s,t)	= 1;
phi_cost(r,"labor",s,t)	= 1;
phi_cost(r,"capital",s,t)= 1;
phi_cons(r,g,hh,t)	= 1;

scn(t)			= no;
IPM_FuelUse(g,t)	= no;
IPM_ELEprc(t)		= no;
IPM_GASprc(t)		= no;
IPM_COLprc(t)		= no;
IPM_Costs(t)		= no;
IPM_FuelExp(g,t)	= no;
IPM_Output(t)		= no;
comp_match(t)		= no;

dm(g)		= %dm%;
mm(g)		= %mm%;
mm(nrg)		= 4;
mm("OIL")	= 6;
dm("ELE")	= 3;
mm("ELE")	= 5;

pref_nr(r,natres,t) = 1;
esub_nr(r,natres,t) = 0;
aeei(r,g,s,t)	= 1;
aeei(r,g,hh,t) = 1;
aeei(r,"moto",hh,t)	= 1;
aeei(r,"heat",hh,t)	= 1;
aeei(r,"MV_man",hh,t)	= 1;
aeei(r,"MV_srv",hh,t)	= 1;
aeei(r,g,"G",t) = 1;
aeei(r,g,"Inv",t) = 1;
nr_grow(r,s,yr)	= qref(yr);

BTU(r,nrg,s)			= id0_EIA("QuadBTU",r,nrg,s,"2005");
BTU(r,nrg,hh)			= cd0_EIA("QuadBTU",r,hh,nrg,"2005");
BTU(r,nrg,"G")			= g0_EIA("QuadBTU",r,nrg,"2005");

BTUs(r,nrg,s,yr)		= id0_EIA("QuadBTU",r,nrg,s,"2005")	* grow_id0("QuadBTU",r,nrg,s,yr);
BTUs(r,nrg,hh,yr)		= cd0_EIA("QuadBTU",r,hh,nrg,"2005")	* grow_cd0("QuadBTU",r,nrg,yr);	 
BTUs(r,nrg,"G",yr)		= g0_EIA("QuadBTU",r,nrg,"2005")	* grow_g0("QuadBTU",r,nrg,yr);	 

BTUs(r,"ELE",s,yr)		= id0_EIA("billKWh",r,"ELE",s,"2005")	* (3412 / 1e+6) * grow_id0("billKWh",r,"ELE",s,yr);
BTUs(r,"ELE",hh,yr)		= cd0_EIA("billKWh",r,hh,"ELE","2005")	* (3412 / 1e+6) * grow_cd0("billKWh",r,"ELE",yr);	 
BTUs(r,"ELE","G",yr)		= g0_EIA("billKWh",r,"ELE","2005")	* (3412 / 1e+6)	* grow_g0("billKWh",r,"ELE",yr);	 

display BTU,BTUs;

FUELconv(r,s,nrg)$id0(r,nrg,s)	= BTUs(r,nrg,s,"2005") / id0(r,nrg,s);
FUELconv(r,hh,nrg)$cd0(r,hh,nrg)= BTUs(r,nrg,hh,"2005") / cd0(r,hh,nrg);
FUELconv(r,"G",nrg)$g0(r,nrg)	= BTUs(r,nrg,"G","2005") / g0(r,nrg);
FUELconv(r,"Avg",nrg)$(sum(s, id0(r,nrg,s)) + sum(hh,cd0(r,hh,nrg)) + g0(r,nrg))
	= sum(alls, BTUs(r,nrg,alls,"2005")) / ( sum(s, id0(r,nrg,s)) + sum(hh,cd0(r,hh,nrg)) + g0(r,nrg));

ELECconv(r) = y0_EIA("billKWh",r,"ELE","2005") - y0_EIA("billKWh",r,"Renew","2005");
RNWconv(r) = y0_EIA("billKWh",r,"Renew","2005");

* implied fuel prices
prc_trgt(r,nrg,t) = 1;

fuelprices(r,nrg,s,t)$BTUs(r,nrg,s,t)
	= ( id0(r,nrg,s) * grow_id0("billion",r,nrg,s,t) )
	/ BTUs(r,nrg,s,t);
fuelprices(r,nrg,hh,t)$BTUs(r,nrg,hh,t)
	= ( cd0(r,hh,nrg) * grow_cd0("billion",r,nrg,t) )
	/ BTUs(r,nrg,hh,t);
fuelprices(r,nrg,"AVG",t)$(sum(s,BTUs(r,nrg,s,t))+sum(hh,BTUs(r,nrg,hh,t)))
	= ( sum(s, id0(r,nrg,s) * grow_id0("billion",r,nrg,s,t)) + sum(hh,cd0(r,hh,nrg) * grow_cd0("billion",r,nrg,t)) )
	/ ( sum(s, BTUs(r,nrg,s,t)) + sum(hh,BTUs(r,nrg,hh,t)) );

display elecconv,fuelconv;



parameter mact_incadj;
* income adjustment to handle residential costs
MACT_incadj(r,hh,t) = 0;

parameter 
	t_cons
;

t_cons(r,s,hh,t) = 0;

parameter x0_coal;
* coal exports by origin-destination
x0_coal(r,reg) = n0(reg,r,"COL") - coal_dist(r,reg);
* Coal transporation costs
parameter trans_mult(r,yr)	coal transporation multiplier;
trans_mult(r,yr)	= 1;

parameter
phi_ref,phi_nr,phi_pa,phi_ele,phi_oil,pr_trgt,pa_trgt,py_trgt,cg_inputs,y_inputs,y_trgt,y0_ff
;

phi_ref(r,g,s,t) = 1;
phi_ref(r,"capital",s,t) = 1;
phi_ref(r,"labor",s,t) = 1;
phi_nr(r,s,t) = 1;
phi_pa(r,s,t) = 1;
phi_ele(r,t) = 1;
phi_oil(r,t) = 1;

cg_inputs(r,s)		= sum(g$(not nrg(g)), id0(r,g,s)*pid0(r,g,s)) + ld0(r,s)*pld0(r,s) + kd0(r,s)*pkd0(r,s);

pr_trgt			= no;
pa_trgt			= no;
py_trgt			= no;

incadj(r,hh)
	= cl0(r,hh) 
	+ lstax(r,hh) 
	- le0(r,hh) 
	- ke0(r,hh)*rk0 
	+ (sum(g, i0(r,g))) * ke0_shr(r,hh) 
	- sum(g, nr_endow(r,hh,g)) 
	- sum(reg, rnw_endow(r,reg,hh));

y0(r,"GAS") = y0(r,"GAS") + gas_dist(r);

d0(r,g)				= y0(r,g) + y0_rnw(r)$eles(g) - x0(r,g,"ftrd") - x0(r,g,"dtrd");
$if %states%==USA	a0(r,g) = d0(r,g) + m0(r,g,"ftrd") + sum(reg,n0(r,reg,g));
$if not %states%==USA	a0(r,g) = d0(r,g) + m0(r,g,"ftrd") + sum(states, n0(r,states,g));

y_inputs(r,"ELE")	= kd0(r,"ELE")*pkd0(r,"ELE") + ld0(r,"ELE")*pld0(r,"ELE");
y_inputs(r,"OIL")	= kd0(r,"OIL")*pkd0(r,"OIL") + ld0(r,"OIL")*pld0(r,"OIL");

y_trgt(r,"OIL",yr)	= qref(yr);
y_trgt(r,"ELE",yr)	= qref(yr);

y0_ff(r)	= y0(r,"ele");

parameter pxref,pmref, pxdref, pmdref;
pxref(r,s,t) = pref(t);
pmref(r,s,t) = pref(t);
pxdref(r,s,t) = pref(t);
pmdref(r,s,t) = pref(t);

parameter chk_mktbal;
chk_mktbal(r,s)
	= y0(r,s)
	+ y0_rnw(r)$ele(s)
	+ oil_dist(r)$oil(s)
*	+ gas_dist(r)$gas(s)
	+ sum(trd, m0(r,s,trd))
	- sum(hh, cd0(r,hh,s))
	- sum(trd, x0(r,s,trd))
	- sum(g, id0(r,s,g))
	- id0_rnw(r,s)
	- sum(reg, coal_dist(r,reg))$trn(s)
	- gas_dist(r)$trn(s)
	- oil_dist(r)$trn(s)
	- g0(r,s)
	- i0(r,s);

chk_mktbal(r,s) = round(chk_mktbal(r,s), 6);

display chk_mktbal,id0,gas_dist;
*$exit

* IPM switches
set switches /IPM_COLuse,IPM_GASuse,IPM_GASexp,IPM_COLexp,IPM_cost,IPM_ELEprc,IPM_GASprc,IPM_COLprc,IPM_supply,Comp_swtch,Supply_swh/;
set switch2 /switch/;

parameter SCN_switch(switches,switch2);  SCN_switch(switches,switch2) = no;

parameter phi_ele_fuel;

phi_ele_fuel(r,g,t) = 1;

parameter govbdgt_adj;

govbdgt_adj(r,t) = 0;

* add household transportation stuff

**--- motor gasoline and heat ---**
parameter
	tran_elas
	ec_elas
	allc_elas
	HHff_elas
	pubt_elas
	gas_elas
	car_elas
	cd0_MVman
	cd0_MVsrv
	chk_MVman
	chk_MVsrv
	cd0_trn
	cd0_moto
	cd0_heat;

tran_elas		= 1;
ec_elas			= 0.25;
allc_elas		= 0.5;
HHff_elas		= 0.4;
pubt_elas		= 0.2;
gas_elas		= 0.4;
car_elas		= 0.5;

cd0_moto(r,hh)$(moto_EIA("billion",r,"2005") + heat_EIA("billion",r,"2005"))
	= cd0(r,hh,"OIL") * moto_EIA("billion",r,"2005") / (moto_EIA("billion",r,"2005") + heat_EIA("billion",r,"2005"));

cd0_heat(r,hh)$(moto_EIA("billion",r,"2005") + heat_EIA("billion",r,"2005"))
	= cd0(r,hh,"OIL") * heat_EIA("billion",r,"2005") / (moto_EIA("billion",r,"2005") + heat_EIA("billion",r,"2005"));

* based on BLS consumption shares (not "MAN")
cd0_MVman(r,hh,man) = cd0(r,hh,man) * 0.1;
cd0_MVsrv(r,hh,"srv")$cd0(r,hh,"srv") = cd0_moto(r,hh) * 1.5;

chk_MVman(r)	= sum((hh,g), cd0_MVman(r,hh,g)) / sum((hh,man), cd0(r,hh,man));
chk_MVsrv(r)	= sum((hh,g), cd0_MVsrv(r,hh,g)) / sum((hh), cd0(r,hh,"srv"));

cd0(r,hh,man)	= cd0(r,hh,man) - cd0_MVman(r,hh,man);
cd0(r,hh,srv)	= cd0(r,hh,srv) - cd0_MVsrv(r,hh,srv);

cd0_trn(r,hh) = cd0_moto(r,hh)*pcd0(r,"OIL") + cd0(r,hh,"trn")*pcd0(r,"TRN") + sum(man,cd0_MVman(r,hh,man)*pcd0(r,man)) + sum(srv,cd0_MVsrv(r,hh,srv)*pcd0(r,srv));

display cd0_moto,cd0_heat,cd0_MVman,cd0_MVsrv,chk_MVman,chk_MVsrv,cd0;

BTU(r,"MOTO",hh)$(moto_EIA("QuadBTU",r,"2005") + heat_EIA("QuadBTU",r,"2005"))
	= cd0_EIA("QuadBTU",r,hh,"OIL","2005")* moto_EIA("QuadBTU",r,"2005") / (moto_EIA("QuadBTU",r,"2005") + heat_EIA("QuadBTU",r,"2005"));
BTU(r,"HEAT",hh)$(moto_EIA("QuadBTU",r,"2005") + heat_EIA("QuadBTU",r,"2005"))
	= cd0_EIA("QuadBTU",r,hh,"OIL","2005")* heat_EIA("QuadBTU",r,"2005") / (moto_EIA("QuadBTU",r,"2005") + heat_EIA("QuadBTU",r,"2005"));

BTU(r,"OIL",hh)			= BTU(r,"MOTO",hh) + BTU(r,"HEAT",hh);

BTUs(r,"MOTO",hh,yr)		= BTU(r,"MOTO",hh) * grow_moto("QuadBTU",r,yr);	 
BTUs(r,"HEAT",hh,yr)		= BTU(r,"HEAT",hh) * grow_heat("QuadBTU",r,yr);	 

BTUs(r,"OIL",hh,yr)		= BTUs(r,"MOTO",hh,yr) + BTUs(r,"HEAT",hh,yr);

FUELconv(r,hh,"MOTO")$cd0_moto(r,hh)= BTUs(r,"MOTO",hh,"2005") / cd0_moto(r,hh);
FUELconv(r,hh,"HEAT")$cd0_heat(r,hh)= BTUs(r,"HEAT",hh,"2005") / cd0_heat(r,hh);

fuelprices(r,"MOTO",hh,t)$BTUs(r,"MOTO",hh,t)
	= ( cd0_moto(r,hh) * grow_moto("billion",r,t) )
	/ BTUs(r,"MOTO",hh,t);

fuelprices(r,"HEAT",hh,t)$BTUs(r,"HEAT",hh,t)
	= ( cd0_heat(r,hh) * grow_heat("billion",r,t) )
	/ BTUs(r,"HEAT",hh,t);

* remove OIL in households 
cd0(r,hh,"OIL") = 0;

$ontext
parameter
	chk_cns;

chk_cns(r,"y0") = y0(r,"cns");
chk_cns(r,"id0") = sum(s,id0(r,"cns",s));
chk_cns(r,"x0_dom") = x0(r,"cns","dtrd");
chk_cns(r,"x0_for") = x0(r,"cns","ftrd");
chk_cns(r,"m0_dom") = m0(r,"cns","dtrd");
chk_cns(r,"m0_for") = m0(r,"cns","ftrd");
chk_cns(r,"cd0") = sum(hh,cd0(r,hh,"cns"));

display chk_cns;
$exit
$offtext

parameter
	pref_bau;

pref_bau(r,t) = pref(t);


$ontext
$model:dynamic
$peps:1e-10

$sectors:
	w(r,hh)
	c(r,hh,yr)$t(yr)
	c_trn(r,hh,yr)$t(yr)						! Consumption of goods by households
	cl(r,hh,yr)$t(yr)
	y(r,s,yr)$(t(yr) and y0(r,s))
	eleinputs(r,g,yr)$(t(yr) and cog(g) and id0(r,g,"ELE"))
	rnw(r,yr)$t(yr)
	e(r,s,yr)$(t(yr) and y0(r,s))
	a(r,s,yr)$(t(yr) and a0(r,s) and not cru(s))
	fexp(r,s,yr)$(t(yr) and x0(r,s,"ftrd") and not cru(s))
	fimp(r,g,yr)$(t(yr) and m0(r,g,"ftrd") and not cru(g))
	dexp(r,s,yr)$(t(yr) and x0(r,s,"dtrd") and not cru(s) and statemod)
	dimp(r,g,yr)$(t(yr) and m0(r,g,"dtrd") and not cru(g) and statemod)
	cruexp(r,yr)$t(yr)
	cruimp(r,yr)$t(yr)
	coalimp(r,yr)$(t(yr) and sum(reg,n0(r,reg,"COL")) and not statemod)			! Domestic coal imports
	coalexp(r,yr)$(t(yr) and sum(reg,n0(r,reg,"COL")) and not statemod)			! Domestic coal exports
	y_gas(r,yr)$(t(yr) and y0(r,"gas"))				! Output of natural gas
	a_oil(r,yr)$(t(yr) and a0(r,"oil"))				! Consumption of oil
	y_goods(r,s,yr)$(t(yr) and y0(r,s) and (oil(s) or eles(s)))
	y_input(r,s,yr)$(t(yr) and y0(r,s) and (oil(s) or eles(s)))
	nr_input(r,s,yr)$(t(yr) and y0(r,s) and colgas(s))
	nr_goods(r,s,yr)$(t(yr) and y0(r,s) and colgas(s))
	a_prc(r,s,yr)$(t(yr) and a0(r,s) and ffe(s))

	gov(r,yr)$t(yr)
	invg(r,yr)$t(yr)
	inv(r,yr)$t(yr)
	k(r,yr)$t(yr)

$commodities:
	pw(r,hh)
	pc(r,hh,yr)$t(yr)
	pc_trn(r,hh,yr)$t(yr)						! Consumption goods price index
	pcl(r,hh,yr)$t(yr)
	py(r,s,yr)$(t(yr) and y0(r,s))
	pd(r,s,yr)$(t(yr) and d0(r,s) and not cru(s))
	pn(r,s,yr)$(t(yr) and (sum(reg,n0(reg,r,s)) or sum(reg,n0(r,reg,s))$col(s)) and not cru(s) and not statemod)	! Regional import price
	pn_col(r,yr)$(t(yr) and sum(reg,n0(reg,r,"COL")))	! Regional coal import price
	py_gas(r,yr)$(t(yr) and y0(r,"gas"))				! Natural gas output prices
	pa_oil(r,yr)$(t(yr) and a0(r,"oil"))				! Oil output prices
	pa_ceg(r,s,yr)$(t(yr) and a0(r,s) and ffe(s))			! Armington good price
	px(r,s,yr)$(t(yr) and x0(r,s,"ftrd") and not cru(s))
	pxd(r,s,yr)$(t(yr) and x0(r,s,"dtrd") and not cru(s) and statemod)
	pm(r,g,yr)$(t(yr) and m0(r,g,"ftrd") and not cru(g))
	pmd(r,g,yr)$(t(yr) and m0(r,g,"dtrd") and not cru(g) and statemod)
	pa(r,s,yr)$(t(yr) and a0(r,s))
	pg(r,yr)$t(yr)
	pl(r,yr)$t(yr)
	rk(r,yr)$t(yr)
	pk(r,yr)$t(yr)
	pka(r,yr)$(t(yr) and pka0)
	pkt(r)
	pci(r,yr)$t(yr)
	pr(r,s,yr)$(t(yr) and nd0(r,s))
	prnw(r,yr)$t(yr)
	pcg(r,g,yr)$(t(yr) and cog(g) and id0(r,g,"ELE"))	
	pinp(r,s,yr)$(t(yr) and y0(r,s) and colgas(s))
	pr_inp(r,s,yr)$(t(yr) and y0(r,s) and colgas(s))
	py_inp(r,s,yr)$(t(yr) and y0(r,s) and (oil(s) or eles(s)))
	py_good(r,s,yr)$(t(yr) and y0(r,s) and (oil(s) or eles(s)))
	pfx

$consumers:
	rh(r,hh)
	govt(r,yr)$t(yr)

$auxiliary:
	kt(r,hh)
	govbdgt(r,yr)$(t(yr) and scn(yr))

	nr_price(r,s,yr)$(t(yr) and y0(r,s) and colgas(s))
	nr_adj(r,s,yr)$(t(yr) and y0(r,s) and colgas(s) and pr_trgt)
	pa_price(r,s,yr)$(t(yr) and a0(r,s) and ffe(s))
	pa_adj(r,s,yr)$(t(yr) and a0(r,s) and ffe(s) and pa_trgt)
	y_lvl(r,s,yr)$(t(yr) and y0(r,s) and (oil(s) or eles(s)))
	y_adj(r,s,yr)$(t(yr) and y0(r,s) and (oil(s) or eles(s)) and py_trgt)

*	ele_output(r,yr)$(t(yr) and IPM_Output(yr))
	ele_price(r,yr)$(t(yr) and IPM_ELEprc(yr))
	adj_eleprice(r,yr)$(t(yr) and IPM_ELEprc(yr))
	gas_price(r,yr)$(t(yr) and IPM_GASprc(yr))
	adj_gasprice(r,yr)$(t(yr) and IPM_GASprc(yr))
	col_price(r,yr)$(t(yr) and IPM_COLprc(yr))
	adj_colprice(r,yr)$(t(yr) and IPM_COLprc(yr))
	ele_fuel(r,g,yr)$(t(yr) and IPM_FuelUse(g,yr) and cog(g))
	adj_fuel(r,g,yr)$(t(yr) and IPM_FuelUse(g,yr))

$prod:y(r,s,t)$(y0(r,s) and indus(s) and not hlt(s))
+	s:0			mat_cru.tl(s):0		eva(s):%eva%	va(eva):%va%
+	enoe(eva):%enoe%	ele.tl(enoe):0		en(enoe):%en%	cog.tl(en):0
o:py(r,s,t)	q:y0(r,s)								a:govt(r,t) t:ty(r,s)
i:pa(r,g,t)	q:(id0(r,g,s)*aeei(r,g,s,t)*phi_ref(r,g,s,t)*phi_cost(r,g,s,t))	g.tl:	p:pid0(r,g,s)	a:govt(r,t) t:ti(r,g,s)
i:pl(r,t)	q:(ld0(r,s)*phi_ref(r,"labor",s,t)*phi_cost(r,"labor",s,t))			va:	p:pld0(r,s)	a:govt(r,t) t:tl(r,s)
i:rk(r,t)	q:(kd0(r,s)*phi_ref(r,"capital",s,t)*phi_cost(r,"capital",s,t))		va:	p:pkd0(r,s)	a:govt(r,t) t:tk(r,s)

$prod:y(r,s,t)$(y0(r,s) and hlt(s))
+	s:0			mat_cru.tl(s):0		eva(s):%eva%	va(eva):%va%
+	enoe(eva):%enoe%	ele.tl(enoe):0		en(enoe):%en%	cog.tl(en):0
o:py(r,s,t)	q:y0(r,s)								a:govt(r,t) t:ty(r,s)
i:pa(r,g,t)	q:(id0(r,g,s)*aeei(r,g,s,t)*phi_ref(r,g,s,t)*phi_cost(r,g,s,t))	g.tl:	p:pid0(r,g,s)	a:govt(r,t) t:ti(r,g,s)
i:pl(r,t)	q:(ld0(r,s)*phi_ref(r,"labor",s,t)*phi_cost(r,"labor",s,t))			va:	p:pld0(r,s)	a:govt(r,t) t:tl(r,s)
i:rk(r,t)	q:(kd0(r,s)*phi_ref(r,"capital",s,t)*phi_cost(r,"capital",s,t))		va:	p:pkd0(r,s)	a:govt(r,t) t:tk(r,s)

$prod:y(r,s,t)$(y0(r,s) and agr(s))		
+		s:%erva%	er(s):%er%	va(s):%va%
+		ae(er):%ae%	mat(ae):0	mat.tl(mat):0
+		enoe(ae):%enoe% ele.tl(enoe):0	en(enoe):%en%	cog.tl(en):0
o:py(r,s,t)	q:(prodshift(r,s,t) * y0(r,s))						a:govt(r,t) t:ty(r,s)  a:govt(r,t) t:costshift(r,s,t)
i:pr(r,s,t)	q:nd0(r,s)					er:	
i:pa(r,g,t)	q:(id0(r,g,s)*aeei(r,g,s,t)*phi_ref(r,g,s,t)*phi_cost(r,g,s,t))	g.tl:	p:pid0(r,g,s)	a:govt(r,t) t:ti(r,g,s)
i:pl(r,t)	q:(ld0(r,s)*phi_ref(r,"labor",s,t)*phi_cost(r,"labor",s,t))			va:	p:pld0(r,s)	a:govt(r,t) t:tl(r,s)
i:rk(r,t)	q:(kd0(r,s)*phi_ref(r,"capital",s,t)*phi_cost(r,"capital",s,t))		va:	p:pkd0(r,s)	a:govt(r,t) t:tk(r,s)

$prod:y(r,s,t)$(y0(r,s) and natres(s) and cru(s))
+		s:esub_nr(r,s,t)	mat:0
o:py(r,s,t)	q:y0(r,s)								a:govt(r,t) t:ty(r,s)
i:pr(r,s,t)	q:nd0(r,s)						p:pref_nr(r,s,t)
i:pa(r,g,t)	q:(id0(r,g,s)*aeei(r,g,s,t)*phi_ref(r,g,s,t)*phi_cost(r,g,s,t))	mat:	p:pid0(r,g,s)			a:govt(r,t) t:ti(r,g,s)
i:pl(r,t)	q:(ld0(r,s)*phi_ref(r,"labor",s,t)*phi_cost(r,"labor",s,t))			mat:	p:pld0(r,s)	a:govt(r,t) t:tl(r,s)
i:rk(r,t)	q:(kd0(r,s)*phi_ref(r,"capital",s,t)*phi_cost(r,"capital",s,t))		mat:	p:pkd0(r,s)		a:govt(r,t) t:tk(r,s)

* Coal production
$prod:y(r,s,t)$(y0(r,s) and col(s))
+		s:esub_nr(r,s,t)	mat:0
o:py(r,s,t)			q:y0(r,s)						a:govt(r,t) t:ty(r,s)
i:pr(r,s,t)			q:nd0(r,s)				p:pref_nr(r,s,t)	   
i:pr_inp(r,s,t)			q:cg_inputs(r,s)		mat:				   
i:pa(r,g,t)$nrg(g)		q:(id0(r,g,s)*aeei(r,g,s,t))	mat:	p:pid0(r,g,s)	a:govt(r,t) t:ti(r,g,s)

* Natural gas production
$prod:y(r,s,t)$(y0(r,s) and gas(s))
+		s:esub_nr(r,s,t)	mat:0
	o:py_gas(r,t)			q:(y0(r,s)-gas_dist(r))					a:govt(r,t) t:ty(r,s)
	i:pr(r,s,t)			q:nd0(r,s)				p:pref_nr(r,s,t)	   
	i:pr_inp(r,s,t)			q:cg_inputs(r,s)		mat:				   
	i:pa(r,g,t)$nrg(g)		q:(id0(r,g,s)*aeei(r,g,s,t))	mat:	p:pid0(r,g,s)	a:govt(r,t) t:ti(r,g,s)

$prod:nr_input(r,s,t)$(y0(r,s) and colgas(s))
	o:pr_inp(r,s,t)			q:(phi_nr(r,s,t)*cg_inputs(r,s))
+		a:rh(r,"HH3")	n:nr_price(r,s,t) m:-1
	i:pinp(r,s,t)			q:cg_inputs(r,s)

$prod:nr_goods(r,s,t)$(y0(r,s) and colgas(s))
	o:pinp(r,s,t)			q:cg_inputs(r,s)
	i:pa(r,g,t)$(not nrg(g))	q:id0(r,g,s)				p:pid0(r,g,s)	a:govt(r,t) t:ti(r,g,s)
	i:pl(r,t)			q:ld0(r,s)				p:pld0(r,s)	a:govt(r,t) t:tl(r,s)
	i:rk(r,t)			q:kd0(r,s)				p:pkd0(r,s)	a:govt(r,t) t:tk(r,s)

$constraint:nr_price(r,s,yr)$(t(yr) and y0(r,s) and colgas(s))
	pr(r,s,yr) - prc_trgt(r,s,yr) * pc(r,"HH3",yr) =e= 0;

$constraint:nr_adj(r,s,yr)$(t(yr) and y0(r,s) and colgas(s) and pr_trgt)
	nr_adj(r,s,yr) =e= nr_price(r,s,yr) * nr_input(r,s,yr) * cg_inputs(r,s);

* Refined petroleum production
$prod:y(r,s,t)$(y0(r,s) and oil(s))	s:0	va(s):%va%
	o:py(r,s,t)			q:y0(r,s)						a:govt(r,t) t:ty(r,s)
	i:pa(r,g,t)			q:(id0(r,g,s)*aeei(r,g,s,t))		p:pid0(r,g,s)	a:govt(r,t) t:ti(r,g,s)
	i:py_inp(r,s,t)			q:y_inputs(r,s)				va:

$prod:y_input(r,s,t)$(y0(r,s) and oil(s))
	o:py_inp(r,s,t)			q:(y_inputs(r,s)*phi_oil(r,t))
+		a:rh(r,"HH3")	n:y_lvl(r,s,t)	m:-1
	i:py_good(r,s,t)		q:y_inputs(r,s)

$prod:y_goods(r,s,t)$(y0(r,s) and oil(s))	s:1
	o:py_good(r,s,t)		q:y_inputs(r,s)
	i:rk(r,t)			q:kd0(r,s)	p:pkd0(r,s)	a:govt(r,t) t:tk(r,s)
	i:pl(r,t)			q:ld0(r,s)	p:pld0(r,s)	a:govt(r,t) t:tl(r,s)

$constraint:y_lvl(r,s,yr)$(t(yr) and y0(r,s) and oil(s))
	y(r,s,yr) - y_trgt(r,s,yr) =e= 0;

$constraint:y_adj(r,s,yr)$(t(yr) and y0(r,s) and oil(s) and py_trgt)
	y_adj(r,s,yr) =e= y_lvl(r,s,yr) * y_input(r,s,yr) * y_inputs(r,s);

* Electricity production from fossil fuels
$prod:y(r,s,t)$(y0(r,s) and eles(s))
+		s:0			mat_cru.tl(s):0		eva(s):%eva_ele%	va(eva):%va%
+		enoe(eva):%enoe%	ele.tl(enoe):0		cog(enoe):%cog%		gas.tl(cog):0 
+		co(cog):%co%		oil.tl(co):0		col.tl(co):0
	o:py(r,s,t)			q:y0_ff(r)							a:govt(r,t) t:ty(r,s)
	i:pa(r,g,t)$(not cog(g))	q:(id0(r,g,s)*aeei(r,g,s,t)*phi_ref(r,g,s,t)*phi_cost(r,g,s,t))		g.tl:	p:pid0(r,g,s)	a:govt(r,t) t:ti(r,g,s)
	i:pcg(r,g,t)$cog(g)		q:(id0(r,g,s)*aeei(r,g,s,t)*phi_ref(r,g,s,t)*phi_cost(r,g,s,t))		g.tl:	p:pid0(r,g,s)	a:govt(r,t) t:ti(r,g,s)
	i:py_inp(r,s,t)			q:y_inputs(r,s)				va:

$prod:y_input(r,s,t)$(y0(r,s) and eles(s))
	o:py_inp(r,s,t)			q:(y_inputs(r,s)*phi_ele(r,t))
+		a:rh(r,"HH3")	n:y_lvl(r,s,t)	m:-1
	i:py_good(r,s,t)		q:y_inputs(r,s)

$prod:y_goods(r,s,t)$(y0(r,s) and eles(s))	s:1
	o:py_good(r,s,t)		q:y_inputs(r,s)
	i:rk(r,t)			q:(kd0(r,s)*phi_ref(r,"capital",s,t)*phi_cost(r,"capital",s,t))	p:pkd0(r,s)	a:govt(r,t) t:tk(r,s)
	i:pl(r,t)			q:(ld0(r,s)*phi_ref(r,"labor",s,t)*phi_cost(r,"labor",s,t))	p:pld0(r,s)	a:govt(r,t) t:tl(r,s)

$prod:eleinputs(r,g,t)$(cog(g) and id0(r,g,"ELE"))
	o:pcg(r,g,t)	q:(id0(r,g,"ELE")*phi_ele_fuel(r,g,t))
+		a:govt(r,t) n:ele_fuel(r,g,t)$(IPM_FuelUse(g,t) and cog(g)) m:-1$(IPM_FuelUse(g,t) and cog(g))
	i:pa(r,g,t)	q:id0(r,g,"ELE")					

$constraint:ele_fuel(r,g,yr)$(t(yr) and IPM_FuelUse(g,yr) and cog(g))
eleinputs(r,g,yr) - inputsbar(r,g,yr) =e= 0;

$constraint:adj_fuel(r,g,yr)$(t(yr) and IPM_FuelUse(g,yr))
adj_fuel(r,g,yr) =e= id0(r,g,"ELE") * eleinputs(r,g,yr) * ele_fuel(r,g,yr);

$constraint:y_lvl(r,s,yr)$(t(yr) and y0(r,s) and eles(s))
	y(r,s,yr) - y_trgt(r,s,yr) =e= 0;

$constraint:y_adj(r,s,yr)$(t(yr) and y0(r,s) and eles(s) and py_trgt)
	y_adj(r,s,yr) =e= y_lvl(r,s,yr) * y_input(r,s,yr) * y_inputs(r,s);

$prod:rnw(r,t)
o:py(r,"ele",t)	q:y0_rnw(r)							a:govt(r,t) t:ty(r,"ele")
i:pa(r,g,t)	q:id0_rnw(r,g)				
i:pl(r,t)	q:ld0_rnw(r)				p:pld0(r,"ele")		a:govt(r,t) t:tl(r,"ele")
i:prnw(r,t)	q:kd0_rnw(r)				p:pkd0(r,"ele")		a:govt(r,t) t:tk(r,"ele")

$prod:a(r,g,t)$(a0(r,g) and not cru(g))			s:dm(g)  d:mm(g)
o:pa(r,g,t)$(not ffe(g))			q:a0(r,g)
o:pa_ceg(r,g,t)$(ffe(g))			q:a0(r,g)
+		a:govt(r,t) n:ele_price(r,t)$(ele(g) and IPM_ELEprc(t)) m:(-1)$(ele(g) and IPM_ELEprc(t))
+		a:govt(r,t) n:gas_price(r,t)$(gas(g) and IPM_GASprc(t)) m:(-1)$(gas(g) and IPM_GASprc(t))
+		a:govt(r,t) n:col_price(r,t)$(col(g) and IPM_COLprc(t)) m:(-1)$(col(g) and IPM_COLprc(t))
i:pd(r,g,t)					q:d0(r,g)			d:
i:pm(r,g,t)					q:m0(r,g,"ftrd")
i:pmd(r,g,t)$statemod				q:m0(r,g,"dtrd")		d:
i:pn(reg,g,t)$(not col(g) and not statemod)	q:n0(r,reg,g)			d:
i:pn(r,g,t)$(col(g) and not statemod)		q:(sum(reg,n0(r,reg,g)))	d:

$constraint:ele_price(r,yr)$(t(yr) and IPM_ELEprc(yr))
pyelebar(r,yr)*pc(r,"HH3",yr) - pa_ceg(r,"ELE",yr) =e= 0;

$constraint:adj_eleprice(r,yr)$(t(yr) and IPM_ELEprc(yr))
adj_eleprice(r,yr) =e= a0(r,"ELE") * a(r,"ELE",yr) * ele_price(r,yr);

$constraint:gas_price(r,yr)$(t(yr) and IPM_GASprc(yr))
pygasbar(r,yr)*pc(r,"HH3",yr) - pa_ceg(r,"GAS",yr) =e= 0;

$constraint:adj_gasprice(r,yr)$(t(yr) and IPM_GASprc(yr))
adj_gasprice(r,yr) =e= a0(r,"GAS") * a(r,"GAS",yr) * gas_price(r,yr);

$constraint:col_price(r,yr)$(t(yr) and IPM_COLprc(yr))
pycolbar(r,yr)*pc(r,"HH3",yr) - pa_ceg(r,"COL",yr) =e= 0;

$constraint:adj_colprice(r,yr)$(t(yr) and IPM_COLprc(yr))
adj_colprice(r,yr) =e= a0(r,"COL") * a(r,"COL",yr) * col_price(r,yr);

$prod:a_prc(r,s,t)$(a0(r,s) and ffe(s) and not oil(s))
	o:pa(r,s,t)			q:(phi_pa(r,s,t)*a0(r,s))
+		a:govt(r,t)	n:pa_price(r,s,t) m:-1
	i:pa_ceg(r,s,t)			q:a0(r,s)

$prod:a_prc(r,s,t)$(a0(r,s) and oil(s))
	o:pa_oil(r,t)			q:(phi_pa(r,s,t)*a0(r,s))
+		a:govt(r,t)	n:pa_price(r,s,t) m:-1
	i:pa_ceg(r,s,t)			q:a0(r,s)

$constraint:pa_price(r,s,yr)$(t(yr) and a0(r,s) and ffe(s) and not oil(s))
	pa(r,s,yr) - prc_trgt(r,s,yr) * pc(r,"HH3",yr) =e= 0;

$constraint:pa_price(r,s,yr)$(t(yr) and a0(r,s) and oil(s))
	pa_oil(r,yr) - prc_trgt(r,s,yr) * pc(r,"HH3",yr) =e= 0;

$constraint:pa_adj(r,s,yr)$(t(yr) and a0(r,s) and ffe(s) and pa_trgt)
	pa_adj(r,s,yr) =e= pa_price(r,s,yr) * a_prc(r,s,yr) * a0(r,s);

$prod:e(r,s,t)$y0(r,s)		t:%t%	s:0
o:pd(r,s,t)$(not cru(s))					q:d0(r,s)
o:px(r,s,t)$(not cru(s))					q:x0(r,s,"ftrd")
o:pxd(r,s,t)$(col(s) and statemod)				q:(sum(reg, n0(reg,r,"COL")))
o:pxd(r,s,t)$(not cru(s) and not col(s) and statemod)		q:x0(r,s,"dtrd")
o:pn(r,s,t)$(not cru(s) and not col(s) and not statemod)	q:x0(r,s,"dtrd")
o:pa(r,s,t)$cru(s)						q:y0(r,s)
i:py(r,s,t)							q:(y0(r,s)-x0(r,s,"dtrd")$col(s)+y0_rnw(r)$(eles(s)))
i:pa(r,"TRN",t)$(col(s) and statemod)				q:(sum(reg, coal_dist(r,reg))*trans_mult(r,t))

$prod:coalexp(reg,t)$(sum(r,n0(reg,r,"COL")) and not statemod)	s:0
o:pn_col(r,t)		q:n0(reg,r,"COL")
i:py(r,"COL",t)		q:x0_coal(r,reg)
i:pa(r,"TRN",t)		q:(coal_dist(r,reg)*trans_mult(r,t))

$prod:coalimp(r,t)$(sum(reg, n0(r,reg,"COL")) and not statemod)	s:0.5
o:pn(r,"COL",t)		q:(sum(reg, n0(r,reg,"COL")))
i:pn_col(reg,t)		q:n0(r,reg,"COL")

* Natural gas distribution
$prod:y_gas(r,t)$y0(r,"GAS")		s:0
o:py(r,"GAS",t)			q:y0(r,"GAS")
i:py_gas(r,t)			q:(y0(r,"GAS") - gas_dist(r))
i:pa(r,"TRN",t)			q:gas_dist(r)							

* Oil distribution
$prod:a_oil(r,t)$a0(r,"OIL")		s:0
o:pa(r,"OIL",t)			q:(a0(r,"OIL")+oil_dist(r))
i:pa_oil(r,t)			q:a0(r,"OIL")
i:pa(r,"TRN",t)			q:oil_dist(r)

$prod:fexp(r,s,t)$(x0(r,s,"ftrd") and not cru(s))
o:pfx		q:(pxref(r,s,t)*x0(r,s,"ftrd"))
i:px(r,s,t)	q:x0(r,s,"ftrd")

$prod:fimp(r,g,t)$(m0(r,g,"ftrd") and not cru(g))
o:pm(r,g,t)	q:m0(r,g,"ftrd")
i:pfx		q:(pmref(r,g,t)*m0(r,g,"ftrd"))

$prod:dexp(r,s,t)$(x0(r,s,"dtrd") and not cru(s) and statemod)
o:pfx		q:(pxdref(r,s,t)*x0(r,s,"dtrd"))
i:pxd(r,s,t)	q:x0(r,s,"dtrd")

$prod:dimp(r,g,t)$(m0(r,g,"dtrd") and not cru(g) and statemod)
o:pmd(r,g,t)	q:m0(r,g,"dtrd")
i:pfx		q:(pmdref(r,g,t)*m0(r,g,"dtrd"))

$prod:cruexp(r,t)
o:pfx			q:pxcru(t)
i:pa(r,"cru",t)		q:1
i:pl(r,t)		q:1e-5

$prod:cruimp(r,t)
o:pa(r,"cru",t)		q:1
i:pfx			q:pmcru(t)

$prod:k(r,yr)$t(yr)
o:pkt(r)$tt(yr)		q:(kendow0(r)*(1-delta))
o:pk(r,yr+5)		q:(kendow0(r)*(1-delta))
o:rk(r,yr)		q:(kendow0(r)*rk0)
o:pka(r,yr)$pka0	q:(kendow0(r)*pka0)
i:pk(r,yr)		q:kendow0(r)

$prod:inv(r,yr)$t(yr)	s:0  adj:1
o:pkt(r)$tt(yr)		q:jinv0(r)
o:pk(r,yr+5)		q:jinv0(r)
i:pci(r,yr)		q:jinv0(r)
i:pka(r,yr)$pka0	q:(jinv0(r)*%phi%*(delta+gamma)/2)  adj:
i:pci(r,yr)		q:(jinv0(r)*%phi%*(delta+gamma)/2)  adj:
	
$prod:invg(r,t)		s:0
o:pci(r,t)		q:inv0(r)
i:pa(r,g,t)		q:(i0(r,g)*aeei(r,g,"Inv",t))

$prod:gov(r,t)		s:0  g.tl(s):0
o:pg(r,t)		q:gov0(r)
i:pa(r,g,t)		q:(g0(r,g)*aeei(r,g,"G",t))

* Consumer goods
$prod:c(r,hh,t)				
+	s:tran_elas	ec(s):ec_elas	allc(ec):allc_elas	cong.tl(allc):0	HHff(ec):HHff_elas	ffe.tl(HHff):0
o:pc(r,hh,t)			q:c0(r,hh)
i:pc_trn(r,hh,t)		q:cd0_trn(r,hh)					p:pref(t)			
i:pa(r,g,t)$(not oiltrn(g) and not hlt(g))	q:(cd0(r,hh,g)*aeei(r,g,hh,t))			p:(pref(t)*pcd0(r,g))		g.tl:$(not cru(g) and not oiltrn(g))	a:govt(r,t) t:tc(r,g)
i:pa(r,g,t)$hlt(g)				q:(phi_cons(r,"HLT",hh,t)*cd0(r,hh,"hlt")*aeei(r,"hlt",hh,t))		p:(pref(t)*pcd0(r,"hlt"))	g.tl:$(hlt(g))				a:govt(r,t) t:tc(r,"hlt")
i:pa(r,g,t)$oil(g)				q:(cd0_heat(r,hh)*aeei(r,"heat",hh,t))		p:(pref(t)*pcd0(r,"OIL"))	g.tl:$(oil(g))				a:govt(r,t) t:tc(r,"OIL")

$prod:c_trn(r,hh,t)
+	s:pubt_elas		trn.tl(s):0	gas(s):gas_elas		oil.tl(gas):0	car(gas):car_elas	man.tl(car):0	srv.tl(car):0
o:pc_trn(r,hh,t)		q:cd0_trn(r,hh)					
i:pa(r,g,t)$trn(g)		q:cd0(r,hh,g)					p:pcd0(r,g)	g.tl:		a:govt(r,t) t:tc(r,g)
i:pa(r,g,t)$man(g)		q:(phi_cons(r,g,hh,t)*cd0_MVman(r,hh,g)*aeei(r,"MV_man",hh,t))	p:pcd0(r,g)	g.tl:		a:govt(r,t) t:tc(r,g)
i:pa(r,g,t)$srv(g)		q:(phi_cons(r,g,hh,t)*cd0_MVsrv(r,hh,g)*aeei(r,"MV_srv",hh,t))	p:pcd0(r,g)	g.tl:		a:govt(r,t) t:tc(r,g)
i:pa(r,g,t)$oil(g)		q:(phi_cons(r,g,hh,t)*cd0_moto(r,hh)*aeei(r,"moto",hh,t))	p:pcd0(r,g)	g.tl:		a:govt(r,t) t:tc(r,g)	a:rh(r,hh) t:t_cons(r,"oil",hh,t)


$prod:cl(r,hh,t)	s:sigma_cl(r,hh)
o:pcl(r,hh,t)		q:cl0(r,hh)
i:pc(r,hh,t)		q:c0(r,hh)			
i:pl(r,t)		q:leis0(r,hh)		

$prod:w(r,hh)		s:%w%
o:pw(r,hh)		q:(cl0(r,hh)*sum(t,pref(t)*GDPgrowth(r,t)))
i:pcl(r,hh,t)		q:(cl0(r,hh)*GDPgrowth(r,t))	p:pref(t)

$demand:rh(r,hh)
e:pr(reg,colgas,t)	q:(natres_endow(r,reg,hh,colgas,t))
e:pr(reg,agr,t)		q:(natres_endow(r,reg,hh,agr,t))
e:pr(reg,cru,t)		q:(natres_endow(r,reg,hh,cru,t))
e:prnw(reg,t)		q:(rnw_endow(r,reg,hh) * rnw_grow(reg,t))
e:pl(r,t)		q:(lab_endow(r,hh,t))
e:pk(r,t0)		q:ke0(r,hh)
e:pfx			q:(incadj(r,hh) * sum(t,pref(t)*GDPgrowth(r,t)))
e:pkt(r)		q:(-1) r:kt(r,hh)
e:pw(r,hh)#(t)		q:(-lstax(r,hh) * pref(t) * GDPgrowth(r,t))		

e:pfx#(t)		q:inc_shr(r,hh)$scn(t)	r:govbdgt(r,t)$scn(t)
d:pw(r,hh)		q:(cl0(r,hh)*sum(t,pref(t)*GDPgrowth(r,t)))
e:pr_inp(r,s,t)$(y0(r,s) and colgas(s) and pr_trgt and hh3(hh))			q:1	r:nr_adj(r,s,t)$(y0(r,s) and colgas(s) and pr_trgt and hh3(hh))
e:py_inp(r,s,t)$(y0(r,s) and (oil(s) or eles(s)) and py_trgt and hh3(hh))	q:1	r:y_adj(r,s,t)$(y0(r,s) and (oil(s) or eles(s)) and py_trgt and hh3(hh))

* goverment budget adjustment for CAIR
e:pfx#(t)		q:(inc_shr(r,hh)*govbdgt_adj(r,t))

* income adjustment for RES costs
e:pw(r,hh)#(t)		q:(-MACT_incadj(r,hh,t)*pref_bau(r,t))


$demand:govt(r,t)
*e:py(r,s,t)		q:(-1)$(eles(s) and IPM_Output(t))	r:ele_output(r,t)$IPM_Output(t)
e:pa_ceg(r,"ELE",t)	q:1$IPM_ELEprc(t)			r:adj_eleprice(r,t)$IPM_ELEprc(t)
e:pa_ceg(r,"GAS",t)	q:1$IPM_GASprc(t)			r:adj_gasprice(r,t)$IPM_GASprc(t)
e:pa_ceg(r,"COL",t)	q:1$IPM_COLprc(t)			r:adj_colprice(r,t)$IPM_COLprc(t)

e:pa(r,s,t)$(a0(r,s) and ffe(s) and not oil(s) and pa_trgt)	q:1	r:pa_adj(r,s,t)$(a0(r,s) and ffe(s) and not oil(s) and pa_trgt)
e:pa_oil(r,t)$(a0(r,"OIL") and pa_trgt)				q:1	r:pa_adj(r,"OIL",t)$(a0(r,"OIL") and pa_trgt)

e:pcg(r,g,t)		q:1$IPM_FuelUse(g,t)			r:adj_fuel(r,g,t)$IPM_FuelUse(g,t)

* goverment budget adjustment for CAIR
e:pfx			q:(-govbdgt_adj(r,t))

e:pw(r,hh)		 q:(lstax(r,hh) * pref(t) * GDPgrowth(r,t))		
e:pw(r,hh)#(r,hh)$scn(t) q:(-1)$scn(t)			r:govbdgt(r,t)$scn(t)


d:pg(r,t)		q:(gov0(r) * GDPgrowth(r,t))

$constraint:kt(r,hh)
sum(tt(yr), inv(r,yr)*c(r,hh,yr-5) - inv(r,yr-5)*c(r,hh,yr)) =e= 0;

$constraint:govbdgt(r,yr)$(t(yr) and scn(yr))
govt(r,yr) * pfx =e= pg(r,yr) * sum(g,g0(r,g)) * gov_bau(r,yr);

$report:
v:cons_good(r,hh,g,yr)$t(yr)				i:pa(r,g,yr)	prod:c(r,hh,yr)
v:cons_tran(r,hh,g,yr)$t(yr)				i:pa(r,g,yr)	prod:c_trn(r,hh,yr)
v:cons_gov(r,g,yr)$t(yr)				i:pa(r,g,yr)	prod:gov(r,yr)
v:cons_inv(r,g,yr)$t(yr)				i:pa(r,g,yr)	prod:invg(r,yr)
v:cons_allg(r,hh,yr)$t(yr)				i:pc(r,hh,yr)	prod:cl(r,hh,yr)
v:cons_leis(r,hh,yr)$t(yr)				i:pl(r,yr)	prod:cl(r,hh,yr)
v:fuely(r,g,s,yr)$(t(yr) and nrg(g) and not eles(s))	i:pa(r,g,yr)	prod:y(r,s,yr)
*v:fuely(r,g,s,yr)$(t(yr) and nrg(g) and eles(s))	i:pa(r,g,yr)	prod:y(r,s,yr)
v:fuely(r,g,s,yr)$(t(yr) and nrg(g) and not cog(g) and eles(s))	i:pa(r,g,yr) prod:y(r,s,yr)
v:fuely(r,g,s,yr)$(t(yr) and cog(g) and eles(s))	i:pcg(r,g,yr)	prod:y(r,s,yr)
v:fuelc(r,hh,nrg,yr)$t(yr)				i:pa(r,nrg,yr)	prod:c(r,hh,yr)
v:fuelmoto(r,hh,yr)$t(yr)				i:pa(r,"OIL",yr)	prod:c_trn(r,hh,yr)
v:fuelg(r,nrg,yr)$t(yr)					i:pa(r,nrg,yr)	prod:gov(r,yr)
v:emply(r,s,yr)$(t(yr) and not eleoil(s) and not colgas(s))	i:pl(r,yr)	prod:y(r,s,yr)
v:emply(r,s,yr)$(t(yr) and eleoil(s))			i:pl(r,yr)	prod:y_goods(r,s,yr)
v:emply(r,s,yr)$(t(yr) and colgas(s))			i:pl(r,yr)	prod:nr_goods(r,s,yr)
v:capy(r,s,yr)$(t(yr) and not eleoil(s))		i:rk(r,yr)	prod:y(r,s,yr)
v:capy(r,s,yr)$(t(yr) and eleoil(s))			i:rk(r,yr)	prod:y_goods(r,s,yr)
v:emplrnw(r,yr)$t(yr)					i:pl(r,yr)	prod:rnw(r,yr)
v:intrnw(r,g,yr)					i:pa(r,g,yr)	prod:rnw(r,yr)
v:cappry(r,s,yr)$t(yr)					i:pr(r,s,yr)	prod:y(r,s,yr)
v:caprnw(r,yr)$t(yr)					i:prnw(r,yr)	prod:rnw(r,yr)
v:intgood(r,g,s,yr)$(t(yr) and not eles(s))		i:pa(r,g,yr)	prod:y(r,s,yr)
v:intgood(r,g,s,yr)$(t(yr) and not cog(g) and eles(s))	i:pa(r,g,yr)	prod:y(r,s,yr)
v:intgood(r,g,s,yr)$(t(yr) and cog(g) and eles(s))	i:pcg(r,g,yr)	prod:y(r,s,yr)
v:domgood(r,s,yr)					i:pd(r,s,yr)	prod:a(r,s,yr)	
v:dcons(r,s,yr)$t(yr)					o:pd(r,s,yr)	prod:e(r,s,yr)
v:fexpg(r,s,yr)$t(yr)					i:px(r,s,yr)	prod:fexp(r,s,yr)
v:fimpg(r,g,yr)$t(yr)					o:pm(r,g,yr)	prod:fimp(r,g,yr)
v:dexpg(r,s,yr)$(t(yr) and not statemod)		o:pn(r,s,yr)	prod:e(r,s,yr)
v:dimpg(r,reg,g,yr)$(t(yr) and not statemod)		i:pn(reg,g,yr)	prod:a(r,g,yr)
v:dexpgST(r,s,yr)$(t(yr) and statemod)			i:pxd(r,s,yr)	prod:dexp(r,s,yr)
v:dimpgST(r,g,yr)$(t(yr) and statemod)			o:pmd(r,g,yr)	prod:dimp(r,g,yr)

v:c_dist(r,reg,yr)		i:pa(r,"trn",yr)	prod:coalexp(reg,yr)
v:o_dist(r,yr)			i:pa(r,"trn",yr)	prod:a_oil(r,yr)
v:g_dist(r,yr)			i:pa(r,"trn",yr)	prod:y_gas(r,yr)
v:output(r,s,yr)		o:py(r,s,yr)		prod:y(r,s,yr)
*v:output(r,s,yr)$gas(s)		o:py(r,s,yr)		prod:y_gas(r,s,yr)
v:output_gas(r,s,yr)		o:py(r,s,yr)		prod:y_gas(r,s,yr)
v:output_rnw(r,yr)		o:py(r,"ele",yr)	prod:rnw(r,yr)
v:invg_out(r,yr)		o:pci(r,yr)		prod:invg(r,yr)
v:a_out(r,g,yr)$(not ffe(g))	o:pa(r,g,yr)		prod:a(r,g,yr)
v:a_out(r,g,yr)$(ffe(g))	o:pa(r,g,yr)		prod:a(r,g,yr)
v:cl_out(r,hh,yr)		o:pcl(r,hh,yr)		prod:cl(r,hh,yr)
v:nr_in(r,g,s,yr)		i:pa(r,g,yr)		prod:nr_goods(r,s,yr)

$offtext
$sysinclude mpsgeset dynamic

c_trn.l(r,hh,t)		= qref(t);
pc_trn.l(r,hh,t)	= pref(t);

nr_input.l(r,s,t)	= qref(t);
nr_goods.l(r,s,t)	= qref(t);
pinp.l(r,s,t)		= pref(t);
pr_inp.l(r,s,t)		= pref(t);
a_prc.l(r,s,t)		= qref(t);
pa_ceg.l(r,s,t)		= pref(t);
y_input.l(r,s,t)	= qref(t);
y_goods.l(r,s,t)	= qref(t);
py_inp.l(r,s,t)		= pref(t);
py_good.l(r,s,t)	= pref(t);

nr_price.lo(r,s,t)	= -0.95;
nr_adj.lo(r,s,t)	= -inf;
pa_price.lo(r,s,t)	= -0.95;
pa_adj.lo(r,s,t)	= -inf;
*y_lvl.lo(r,s,t)		= -0.95;
*y_adj.lo(r,s,t)		= -inf;




y_gas.l(r,t)=qref(t);a_oil.l(r,t)=qref(t);coalimp.l(r,t)=qref(t);coalexp.l(r,t)=qref(t);c.l(r,hh,t) = qref(t);cl.l(r,hh,t) = qref(t);y.l(r,s,t) = qref(t);e.l(r,s,t) = qref(t);a.l(r,s,t) = qref(t);
fexp.l(r,s,t) = qref(t);fimp.l(r,g,t) = qref(t);cruexp.l(r,t) = qref(t)*netexp(r);cruimp.l(r,t) = qref(t)*netimp(r);
dexp.l(r,s,t) = qref(t);dimp.l(r,g,t) = qref(t);
gov.l(r,t) = qref(t);rnw.l(r,t) = qref(t);
eleinputs.l(r,g,t) = qref(t);

pa_oil.l(r,t)=pref(t);py_gas.l(r,t)=pref(t);pn_col.l(r,t)=pref(t);pc.l(r,hh,t) = pref(t);pcl.l(r,hh,t) = pref(t);py.l(r,s,t) = pref(t);pd.l(r,s,t) = pref(t);pn.l(r,s,t) = pref(t);px.l(r,s,t) = pref(t);pm.l(r,g,t) = pref(t);
pxd.l(r,s,t) = pref(t);pmd.l(r,g,t) = pref(t);
pa.l(r,s,t) = pref(t);pci.l(r,t) = pref(t);pg.l(r,t) = pref(t);rk.l(r,t) = pref(t);pl.l(r,t) = pref(t);pr.l(r,s,t) = pref(t);prnw.l(r,t) = pref(t);
pcg.l(r,g,t) = pref(t);
pfx.fx = 1;

invg.l(r,t) = qref(t);inv.l(r,t) = qref(t);k.l(r,t) = qref(t);pk.l(r,t) = pref(t) * pk0;pka.l(r,t) = pref(t);
kt.l(r,hh) = sum(tt, ke0(r,hh)*qref(tt)*(1+gamma));pkt.l(r) = sum(tt, pref(tt)) * pk0/(1+rho);
*nrc.l(r,colgas,t) = 1;

*ele_output.l(r,t) = 1;ele_output.lo(r,t) = -0.95;ele_output.up(r,t) = +inf;
ele_price.l(r,t) = 1;ele_price.lo(r,t) = -0.95;ele_price.up(r,t) = +inf;adj_eleprice.lo(r,t) = -inf;adj_eleprice.up(r,t) = +inf;
gas_price.l(r,t) = 1;gas_price.lo(r,t) = -0.95;gas_price.up(r,t) = +inf;adj_gasprice.lo(r,t) = -inf;adj_gasprice.up(r,t) = +inf;
col_price.l(r,t) = 1;col_price.lo(r,t) = -0.95;col_price.up(r,t) = +inf;adj_colprice.lo(r,t) = -inf;adj_colprice.up(r,t) = +inf;
ele_fuel.l(r,g,t) = 1;ele_fuel.lo(r,g,t) = -0.95;ele_fuel.up(r,g,t) = +inf;
adj_fuel.lo(r,g,t) = -inf;adj_fuel.up(r,g,t) = +inf;

govbdgt.l(r,t) = 1;govbdgt.up(r,t) = +inf;govbdgt.lo(r,t) = -inf;

dynamic.iterlim = 0; 
*dynamic.optfile = 1;
$include dynamic.gen
solve dynamic using mcp;
abort$(dynamic.objval gt 5.e-3) "Error: MPSGE Steady-State Model Does Not Balance.";
dynamic.iterlim = 75000; 
dynamic.reslim = 75000; 

$if %readBAU%==yes	$goto BAUlbl
$if %states%==USA	$include bau_solve.gms

$label BAUlbl
$if %readBAU%==yes	$include readBAU.gms

* turn off price adjustments

phi_nr(r,colgas,t)	= (1 + nr_price.l(r,colgas,t));
nr_price.fx(r,colgas,t)	= 0;
nr_adj.fx(r,colgas,t)	= 0;
pr_trgt			= no;

phi_pa(r,ffe,t)		= (1 + pa_price.l(r,ffe,t));
pa_price.fx(r,ffe,t)	= 0;
pa_adj.fx(r,ffe,t)	= 0;
pa_trgt			= no;

display phi_nr, phi_pa;

**- Handle resource supply elasticities -**

* Calibrate Natural Resource Supply Elasticities to Target Price Path

eta_nr(natres,yr) = 0.3 + (%gr% - 0.3)*(1-exp(-0.08*ord(yr)));
eta_nr(natres,postAEO) = eta_nr(natres,"2030");

eta_nr("COL",yr) = 0.5 + (5 - 0.5)*(1-exp(-0.08*ord(yr)));
eta_nr("COL",postAEO) = eta_nr("COL","2030");

eta_nr("GAS",yr) = 0.3 + (2 - 0.3)*(1-exp(-0.08*ord(yr)));
eta_nr("GAS",postAEO) = eta_nr("GAS","2030");

share_nr(r,natres,t)$y0(r,natres)
	 = ((pr.l(r,natres,t) * nd0(r,natres)) / (py.l(r,natres,t) * (y0(r,natres)-gas_dist(r)$gas(natres)) * (1-ty(r,natres))));

esub_nr(r,natres,t)$(1-share_nr(r,natres,t))
	 = eta_nr(natres,t) * ( share_nr(r,natres,t) / (1-share_nr(r,natres,t)) );

pref_nr(r,"CRU",t)$(nd0(r,"CRU") and y0(r,"CRU"))
	= ( (pr.l(r,"CRU",t)*nd0(r,"CRU") )
		/ ( sum(g,pa.l(r,g,t)*id0(r,g,"CRU")*aeei(r,g,"CRU",t)*pid0(r,g,"CRU")) 
		  + pl.l(r,t)*ld0(r,"CRU")*pld0(r,"CRU")
		  + rk.l(r,t)*kd0(r,"CRU")*pkd0(r,"CRU") ) )
			/ ( nd0(r,"CRU") 
				/ ( sum(g,id0(r,g,"CRU")*aeei(r,g,"CRU",t)*pid0(r,g,"CRU")) 
				  + ld0(r,"CRU")*pld0(r,"CRU") 
				  + kd0(r,"CRU")*pkd0(r,"CRU")  ) );

pref_nr(r,colgas,t)$(nd0(r,colgas) and y0(r,colgas))
	= ( (pr.l(r,colgas,t)*nd0(r,colgas) )
		/ ( sum(g$nrg(g),pa.l(r,g,t)*id0(r,g,colgas)*aeei(r,g,colgas,t)*pid0(r,g,colgas)) 
		  + pr_inp.l(r,colgas,t) * cg_inputs(r,colgas) ) )
			/ ( nd0(r,colgas) 
				/ ( sum(g$nrg(g),id0(r,g,colgas)*aeei(r,g,colgas,t)*pid0(r,g,colgas)) 
				  + cg_inputs(r,colgas) ) );

display share_nr,pref_nr,esub_nr;
dynamic.iterlim = 0;
$include dynamic.gen
solve dynamic using mcp;
*abort$(dynamic.objval gt 1.e-4) "Error: BAU - post pref_nr Does Not Balance.";
dynamic.iterlim = 75000;

scn(t) = yes;

parameter
	save_index
	save_2030;

save_index(r,"1_GSP",t)		= grow_GDP(r,t);
save_index(r,s,t)		= GSP_index(r,s,t);
save_2030(r,"1_GSP","2030")	= (save_index(r,"1_GSP","2030") / save_index(r,"1_GSP","2010"))**(1/20) - 1;
save_2030(r,s,"2030")		= (save_index(r,s,"2030") / save_index(r,s,"2010"))**(1/20) - 1;

display save_index,save_2030;

parameter check3;

check3(r,s,t) = output.l(r,s,t);

display y0, check3;

$include findings1.gms

*$if %readBAU%==yes 
$include policy.gms





